#include "stdafx.h"
#include "spc700.h"
#include "apu.h"
#include "soundux.h"

extern int NoiseFreq[32];
extern uint8 APUROM[64];

#if 0
uint8 S9xAPUGetByteZ(uint8 Address)
{
	uint8 t;

	/* DSP̓ǂݏo */
	if(Address == 0xf3) return S9xGetAPUDSP();
	/* ^C}荞݃tO擾ANA */
	if(Address >= 0xfd && IAPU.DirectPage == IAPU.RAM) {
		t = IAPU.RAM[Address];
		IAPU.RAM[Address] = 0;
		return t;
	}
	/* ʏRAM */
	return IAPU.DirectPage[Address];
}

void S9xAPUSetByteZ(uint8 byte, uint8 Address)
{
	if(Address >= 0xf0 && IAPU.DirectPage == IAPU.RAM) {
		/* DSPւ̏ */
		if(Address == 0xf3) {
			S9xSetAPUDSP(byte);
		/* o̓|[g */
		} else if(Address >= 0xf4 && Address <= 0xf7) {
			APU.OutPorts[Address - 0xf4] = byte;
		/* APU */
		} else if(Address == 0xf1) {
			S9xSetAPUControl(byte);
		/* ^CAbvlݒ */
		} else if(Address < 0xfd) {
			IAPU.RAM[Address] = byte; /* Ƃ肠i[H */
			if(Address >= 0xfa) { /* 0xfa`0xfcȂ^CAbvlݒ */
				if(byte == 0) {
					APU.TimerTarget[Address - 0xfa] = 0x100;
				} else {
					APU.TimerTarget[Address - 0xfa] = byte;
				}
			}
		}
	} else {
		/* ʏRAM */
		IAPU.DirectPage[Address] = byte;
	}
}

uint8 S9xAPUGetByte(uint16 Address)
{
	uint8 t;

	/* DSP̓ǂݏo */
	if(Address == 0xf3) return S9xGetAPUDSP();
	/* ^C}荞݃tO擾ANA */
	if(Address <= 0xff && Address >= 0xfd) {
		t = IAPU.RAM[Address];
		IAPU.RAM[Address] = 0;
		return t;
	}
	/* ROM܂͊gRAM */
	if(Address >= 0xffc0) {
		if(APU.ShowROM) {
			return APUROM[Address - 0xffc0];
		} else {
			return APU.ExtraRAM[Address - 0xffc0];
		}
	}
	/* ʏRAM */
	return IAPU.RAM[Address];
}

void S9xAPUSetByte(uint8 byte, uint16 Address)
{
	if(Address <= 0xff && Address >= 0xf0) { /* 𑁂߂悤u<=0xffvɌ */
		/* DSPւ̏ */
		if(Address == 0xf3) {
			S9xSetAPUDSP(byte);
		/* o̓|[g */
		} else if(Address >= 0xf4 && Address <= 0xf7) {
			APU.OutPorts[Address - 0xf4] = byte;
		/* APU */
		} else if(Address == 0xf1) {
			S9xSetAPUControl(byte);
		/* ^CAbvlݒ */
		} else if(Address < 0xfd) {
			IAPU.RAM[Address] = byte; /* Ƃ肠i[H */
			if(Address >= 0xfa) { /* 0xfa`0xfcȂ^CAbvlݒ */
				if(byte == 0) {
					APU.TimerTarget[Address - 0xfa] = 0x100;
				} else {
					APU.TimerTarget[Address - 0xfa] = byte;
				}
			}
		}
	} else {
		/* ʏRAM */
		if(Address < 0xffc0) {
			IAPU.RAM[Address] = byte;
		/* gRAM */
		} else {
			APU.ExtraRAM[Address - 0xffc0] = byte;
		}
	}
}
#endif

/* APURegister.P({̃tO`)IAPU._*(₷`)ɓWJ܂B */
void S9xAPUUnpackStatus()
{
	/* IAPU._Zero(Zero)APURegister.P(Zero)01tł邱ƂɒӂĂB
	 * APU{̃[tO̓[̂Ƃ1ɂȂ܂B(ʓIȃ[tOƓӂ܂)
	 * IAPU._Zeroł͊ȒP̂߂ɁA[̂Ƃ0A[̂Ƃ1ɂȂ܂B
	 */
	IAPU._Zero = ((APURegisters.P & Zero) == 0) | (APURegisters.P & Negative);
	IAPU._Carry = (APURegisters.P & Carry);
	IAPU._Overflow = (APURegisters.P & Overflow) >> 6;
}

/* IAPU._*(₷`)APURegister.P({̃tO`)ɖ߂܂B */
void S9xAPUPackStatus()
{
	APURegisters.P &= ~(Zero | Negative | Carry | Overflow);
	APURegisters.P |= (IAPU._Carry) |		/* bit0:Carry */
			  ((IAPU._Zero == 0) << 1) |	/* bit1:Zero */
			  (IAPU._Zero & 0x80) |		/* bit7:Negative */
			  (IAPU._Overflow << 6);	/* bit6:Overflow */
}

/* APŨZbgB
 * SPCt@C[hOɌĂ΂ꂽA[heŏ㏑܂B
 * SPCt@CɊ܂܂Ȃ̏l^邽߂̊֐Ǝv܂B
 */
void S9xResetAPU()
{
	/* ͂낢ĂǁAKȃNAɒuĂ݂܂B */
	memset(&APURegisters, 0, sizeof APURegisters);
	memset(&IAPU, 0, sizeof IAPU);
	memset(&APU, 0, sizeof APU);
	memset(&SoundData, 0, sizeof SoundData);
}

void S9xSetAPUDSP(uint8 byte)
{
	uint8 reg = IAPU.RAM[0xf2] & 0x7f;
	int c;

	switch(reg) {
	case APU_FLG:
		if(byte & APU_SOFT_RESET) {
			APU.DSP[reg] = APU_MUTE | APU_ECHO_DISABLED | (byte & 0x1f);
			APU.DSP[APU_ENDX] = 0xff;
			APU.DSP[APU_KOFF] = 0;
			APU.DSP[APU_KON] = 0;
			S9xSetEchoWriteEnable(0);
			// Kill sound
			S9xResetSound();
		} else {
			if(byte & APU_ECHO_DISABLED) {
				S9xSetEchoWriteEnable(0);
			} else {
				S9xSetEchoWriteEnable(1);
			}
			if(byte & APU_MUTE) {
				S9xSetSoundMute(1);
			} else {
				S9xSetSoundMute(0);
			}
		}
		break;
	case APU_NON:
		if(byte != APU.DSP[APU_NON]) {
			uint8 mask = 1;
			for(c = 0; c < 8; c++, mask <<= 1) {
				int type;
				if(byte & mask) {
					type = SOUND_NOISE;
				} else {
					type = SOUND_SAMPLE;
				}
				S9xSetSoundType(c, type);
			}
		}
		break;
	case APU_MVOL_LEFT:
		if(byte != APU.DSP[APU_MVOL_LEFT]) {
			S9xSetMasterVolume((char) byte,
							 (char) APU.DSP[APU_MVOL_RIGHT]);
		}
		break;
	case APU_MVOL_RIGHT:
		if(byte != APU.DSP[APU_MVOL_RIGHT]) {
			S9xSetMasterVolume((char) APU.DSP[APU_MVOL_LEFT],
							 (char) byte);
		}
		break;
	case APU_EVOL_LEFT:
		if(byte != APU.DSP[APU_EVOL_LEFT]) {
			S9xSetEchoVolume((char) byte,
							(char) APU.DSP[APU_EVOL_RIGHT]);
		}
		break;
	case APU_EVOL_RIGHT:
		if(byte != APU.DSP[APU_EVOL_RIGHT]) {
			S9xSetEchoVolume((char) APU.DSP[APU_EVOL_LEFT],
							(char) byte);
		}
		break;
	case APU_ENDX:
		byte = 0;
		break;

	case APU_KOFF:
		if(byte) {
			uint8 mask = 1;
			for(c = 0; c < 8; c++, mask <<= 1) {
				if((byte & mask) != 0) {
					if(APU.KeyedChannels & mask) {
						APU.KeyedChannels &= ~mask;
						APU.DSP[APU_KON] &= ~mask;
						APU.DSP[APU_KOFF] |= mask;
						S9xSetSoundKeyOff(c);
					}
				}
			}
		}
		APU.DSP[APU_KOFF] = byte;
		return;
	case APU_KON:
		if(byte) {
			uint8 mask = 1;
			for(c = 0; c < 8; c++, mask <<= 1) {
				if((byte & mask) != 0) {
					APU.KeyedChannels |= mask;
					APU.DSP[APU_KON] |= mask;
					StartSample(c);
				}
			}
		}
		return;
		
	case APU_VOL_LEFT + 0x00:
	case APU_VOL_LEFT + 0x10:
	case APU_VOL_LEFT + 0x20:
	case APU_VOL_LEFT + 0x30:
	case APU_VOL_LEFT + 0x40:
	case APU_VOL_LEFT + 0x50:
	case APU_VOL_LEFT + 0x60:
	case APU_VOL_LEFT + 0x70:
		if(byte != APU.DSP[reg]) {
			S9xSetSoundVolume(reg >> 4, (char) byte,
							(char) APU.DSP[reg + 1]);
		}
		break;
	case APU_VOL_RIGHT + 0x00:
	case APU_VOL_RIGHT + 0x10:
	case APU_VOL_RIGHT + 0x20:
	case APU_VOL_RIGHT + 0x30:
	case APU_VOL_RIGHT + 0x40:
	case APU_VOL_RIGHT + 0x50:
	case APU_VOL_RIGHT + 0x60:
	case APU_VOL_RIGHT + 0x70:
		if(byte != APU.DSP[reg]) {
			S9xSetSoundVolume(reg >> 4, (char) APU.DSP[reg - 1],
							(char) byte);
		}
		break;

	case APU_P_LOW + 0x00:
	case APU_P_LOW + 0x10:
	case APU_P_LOW + 0x20:
	case APU_P_LOW + 0x30:
	case APU_P_LOW + 0x40:
	case APU_P_LOW + 0x50:
	case APU_P_LOW + 0x60:
	case APU_P_LOW + 0x70:
		S9xSetSoundFrequency(reg >> 4, ((byte + (APU.DSP[reg + 1] << 8)) & FREQUENCY_MASK) * 8);
		break;

	case APU_P_HIGH + 0x00:
	case APU_P_HIGH + 0x10:
	case APU_P_HIGH + 0x20:
	case APU_P_HIGH + 0x30:
	case APU_P_HIGH + 0x40:
	case APU_P_HIGH + 0x50:
	case APU_P_HIGH + 0x60:
	case APU_P_HIGH + 0x70:
		S9xSetSoundFrequency(reg >> 4, (((byte << 8) + APU.DSP[reg - 1]) & FREQUENCY_MASK) * 8);
		break;

	case APU_SRCN + 0x00:
	case APU_SRCN + 0x10:
	case APU_SRCN + 0x20:
	case APU_SRCN + 0x30:
	case APU_SRCN + 0x40:
	case APU_SRCN + 0x50:
	case APU_SRCN + 0x60:
	case APU_SRCN + 0x70:
		if(byte != APU.DSP[reg]) {
			S9xSetSoundSample(reg >> 4, byte);
		}
		break;
		
	case APU_ADSR1 + 0x00:
	case APU_ADSR1 + 0x10:
	case APU_ADSR1 + 0x20:
	case APU_ADSR1 + 0x30:
	case APU_ADSR1 + 0x40:
	case APU_ADSR1 + 0x50:
	case APU_ADSR1 + 0x60:
	case APU_ADSR1 + 0x70:
		if(byte != APU.DSP[reg]) {
			FixEnvelope(reg >> 4, APU.DSP[reg + 2], byte, APU.DSP[reg + 1]);
		}
		break;

	case APU_ADSR2 + 0x00:
	case APU_ADSR2 + 0x10:
	case APU_ADSR2 + 0x20:
	case APU_ADSR2 + 0x30:
	case APU_ADSR2 + 0x40:
	case APU_ADSR2 + 0x50:
	case APU_ADSR2 + 0x60:
	case APU_ADSR2 + 0x70:
		if(byte != APU.DSP[reg]) {
			FixEnvelope(reg >> 4, APU.DSP[reg + 1], APU.DSP[reg - 1], byte);
		}
		break;

	case APU_GAIN + 0x00:
	case APU_GAIN + 0x10:
	case APU_GAIN + 0x20:
	case APU_GAIN + 0x30:
	case APU_GAIN + 0x40:
	case APU_GAIN + 0x50:
	case APU_GAIN + 0x60:
	case APU_GAIN + 0x70:
		if(byte != APU.DSP[reg]) {
			FixEnvelope(reg >> 4, byte, APU.DSP[reg - 2], APU.DSP[reg - 1]);
		}
		break;

	case APU_ENVX + 0x00:
	case APU_ENVX + 0x10:
	case APU_ENVX + 0x20:
	case APU_ENVX + 0x30:
	case APU_ENVX + 0x40:
	case APU_ENVX + 0x50:
	case APU_ENVX + 0x60:
	case APU_ENVX + 0x70:
		break;

	case APU_OUTX + 0x00:
	case APU_OUTX + 0x10:
	case APU_OUTX + 0x20:
	case APU_OUTX + 0x30:
	case APU_OUTX + 0x40:
	case APU_OUTX + 0x50:
	case APU_OUTX + 0x60:
	case APU_OUTX + 0x70:
		break;
	
	case APU_DIR:
		break;

	case APU_PMON:
		if(byte != APU.DSP[reg]) {
			S9xSetFrequencyModulationEnable(byte);
		}
		break;

	case APU_EON:
		if(byte != APU.DSP[APU_EON]) {
			S9xSetEchoEnable(byte);
		}
		break;

	case APU_EFB:
		S9xSetEchoFeedback((char)byte);
		break;

	case APU_ESA:
		break;

	case APU_EDL:
		/*if(byte & 0xf != APU.DSP[APU_EDL]) Ԃ񌳂̊ԈႢH*/
		if((byte & 0xf) != APU.DSP[APU_EDL]) {
			S9xSetEchoDelay(byte & 0xf);
		}
		break;

	case APU_C0:
	case APU_C1:
	case APU_C2:
	case APU_C3:
	case APU_C4:
	case APU_C5:
	case APU_C6:
	case APU_C7:
		S9xSetFilterCoefficient(reg >> 4, (char) byte);
		break;
	default:
		break;
	}

	APU.DSP[reg] = byte;
}


void FixEnvelope(int channel, uint8 gain, uint8 adsr1, uint8 adsr2)
{
	if(adsr1 & 0x80) {
		// ADSR mode
		static uint32 AttackRate[16] = {
			4100, 2600, 1500, 1000, 640, 380, 260, 160,
			96, 64, 40, 24, 16, 10, 6, 0
		};
		static uint32 DecayRate[8] = {
			1200, 740, 440, 290, 180, 110, 74, 37
		};
		static uint32 SustainRate[32] = {
			~0, 38000, 28000, 24000, 19000, 14000, 12000, 9400,
			7100, 5900, 4700, 3500, 2900, 2400, 1800, 1500,
			1200, 880, 740, 590, 440, 370, 290, 220,
			180, 150, 110, 92, 74, 55, 37, 18
		};
		if(S9xSetSoundMode(channel, SOUND_MODE_ADSR) == SOUND_MODE_ADSR) {
			S9xSetSoundADSR(channel, AttackRate[adsr1 & 0xf],
						 DecayRate[(adsr1 >> 4) & 7],
						 SustainRate[adsr2 & 0x1f],
						 (adsr2 >> 5) & 7, 8);
		}
	} else {
		// Gain mode
		if((gain & 0x80) == 0) {
			if(S9xSetSoundMode(channel, SOUND_MODE_GAIN) == SOUND_MODE_GAIN)
			{
				S9xSetSoundADSR(channel, 0, 0, ~0, 7, 8);
				S9xSetEnvelopeHeight(channel, gain & 0x7f);
			}
		} else {
			static uint32 IncreaseRate[32] = {
				~0, 4100, 3100, 2600, 2000, 1500, 1300, 1000,
				770, 640, 510, 380, 320, 260, 190, 160,
				130, 96, 80, 64, 48, 40, 32, 24,
				20, 16, 12, 10, 8, 6, 4, 2
			};
			static uint32 DecreaseRateExp[32] = {
				~0, 38000, 28000, 24000, 19000, 14000, 12000, 9400,
				7100, 5900, 4700, 3500, 2900, 2400, 1800, 1500,
				1200, 880, 740, 590, 440, 370, 290, 220,
				180, 150, 110, 92, 74, 55, 37, 18
			};
			if(gain & 0x40) {
				// Increase mode
				// XXX: Bent curve or straight line
				if(S9xSetSoundMode(channel, SOUND_MODE_INCREASE) == SOUND_MODE_INCREASE)
				{
					S9xSetSoundADSR(channel, IncreaseRate[gain & 0x1f],
								  ~0, ~0, 7, 8);
				}
			} else {
				// XXX: Bent curve or straight line
				// Switch to decrease mode from ADSR mode
				if(S9xSetSoundMode(channel, SOUND_MODE_DECREASE) == SOUND_MODE_DECREASE) {
					S9xSetSoundADSR(channel, 0,
								  (gain & 0x20) != 0 ? DecreaseRateExp[gain & 0x1f] :
								  IncreaseRate[gain & 0x1f], ~0, 7, 8);
					S9xSetSoundDecayMode(channel);
				}
			}
		}
	}
}


void S9xSetAPUControl(uint8 byte)
{
	if((byte & 1) != 0 && !APU.TimerEnabled[0])
	{
		APU.Timer[0] = 0;
		IAPU.RAM[0xfd] = 0;
		if((APU.TimerTarget[0] = IAPU.RAM[0xfa]) == 0)
			APU.TimerTarget[0] = 0x100;
	}
	if((byte & 2) != 0 && !APU.TimerEnabled[1])
	{
		APU.Timer[1] = 0;
		IAPU.RAM[0xfe] = 0;
		if((APU.TimerTarget[1] = IAPU.RAM[0xfb]) == 0)
			APU.TimerTarget[1] = 0x100;
	}
	if((byte & 4) != 0 && !APU.TimerEnabled[2])
	{
		APU.Timer[2] = 0;
		IAPU.RAM[0xff] = 0;
		if((APU.TimerTarget[2] = IAPU.RAM[0xfc]) == 0)
			APU.TimerTarget[2] = 0x100;
	}
	APU.TimerEnabled[0] = byte & 1;
	APU.TimerEnabled[1] = (byte & 2) >> 1;
	APU.TimerEnabled[2] = (byte & 4) >> 2;

	if(byte & 0x10)
		IAPU.RAM[0xF4] = IAPU.RAM[0xF5] = 0;

	if(byte & 0x20)
		IAPU.RAM[0xF6] = IAPU.RAM[0xF7] = 0;

	if(byte & 0x80)
		APU.ShowROM = 1;
	else
		APU.ShowROM = 0;
	IAPU.RAM[0xf1] = byte;
}

uint8 S9xGetAPUDSP()
{
	uint8 reg = IAPU.RAM[0xf2] & 0x7f;
	uint8 byte = APU.DSP[reg];

	switch(reg) {
	case APU_OUTX + 0x00:
	case APU_OUTX + 0x10:
	case APU_OUTX + 0x20:
	case APU_OUTX + 0x30:
	case APU_OUTX + 0x40:
	case APU_OUTX + 0x50:
	case APU_OUTX + 0x60:
	case APU_OUTX + 0x70:
		return byte;
		break;

	case APU_ENVX + 0x00:
	case APU_ENVX + 0x10:
	case APU_ENVX + 0x20:
	case APU_ENVX + 0x30:
	case APU_ENVX + 0x40:
	case APU_ENVX + 0x50:
	case APU_ENVX + 0x60:
	case APU_ENVX + 0x70:
		return (uint8) S9xGetEnvelopeHeight(reg >> 4);

	case APU_ENDX:
		APU.DSP[APU_ENDX] = 0;
		break;
	default:
		break;
	}
	return byte;
}

void S9xAPUSetEndOfSample(int ch)
{
	APU.DSP[APU_ENDX] |= 1 << ch;
	APU.DSP[APU_KON] &= ~(1 << ch);
	APU.DSP[APU_KOFF] &= ~(1 << ch);
}

void S9xAPUSetEndX(int ch)
{
	APU.DSP[APU_ENDX] |= 1 << ch;
}

void StartSample(int c)
{
	// Convert sample and start playing sound
	uint16 sample_number = APU.DSP[APU_SRCN + c * 0x10];
	int freq;
	int type;
	if(APU.DSP[APU_NON] & (1 << c))
	{
		type = SOUND_NOISE;
		freq = NoiseFreq[APU.DSP[APU_FLG] & 0x1f];
	}
	else
	{
		type = SOUND_SAMPLE;
		freq = ((APU.DSP[APU_P_LOW  + c * 0x10] +
			(APU.DSP[APU_P_HIGH + c * 0x10] << 8)) & FREQUENCY_MASK) * 8;
	}
	S9xSetSoundMode(c, SOUND_MODE_NONE);
	FixEnvelope(c, 
				 APU.DSP[APU_GAIN  + (c << 4)], 
				 APU.DSP[APU_ADSR1 + (c << 4)],
				 APU.DSP[APU_ADSR2 + (c << 4)]);

	S9xPlaySample(c, type,
				(char) APU.DSP[APU_VOL_LEFT + c * 0x10],
				(char) APU.DSP[APU_VOL_RIGHT + c * 0x10],
				freq, sample_number);
}

