#ifndef _APU_H_
#define _APU_H_

/* ₷WJAPUWX^RAMȂ */
typedef struct _SIAPU {
	uint8* PC;
	uint8 RAM[0x10000];
	uint8* DirectPage;
	uint8 Bit;
	uint32 Address;
	uint8 _Carry;
	uint8 _Zero;
	uint8 _Overflow;
	uint32 TimerErrorCounter;
} SIAPU;
extern SIAPU IAPU;

/* APURAMTCNJE^Ȃǂ̊ */
typedef struct _SAPU {
	bool8 ShowROM;
	uint8 KeyedChannels;
	uint8 OutPorts[4];
	uint8 DSP[0x80];
	uint8 ExtraRAM[64];
	uint16 Timer[3];
	uint16 TimerTarget[3];
	bool8 TimerEnabled[3];
} SAPU;
extern SAPU APU;

uint8 S9xAPUGetByteZ(uint8 Address);
void S9xAPUSetByteZ(uint8 byte, uint8 Address);
uint8 S9xAPUGetByte(uint16 Address);
void S9xAPUSetByte(uint8 byte, uint16 Address);

void S9xAPUUnpackStatus();
void S9xAPUPackStatus();
void S9xResetAPU();
void S9xDecacheSamples();
void S9xSetAPUControl (uint8 byte);
void S9xSetAPUDSP (uint8 byte);
uint8 S9xGetAPUDSP();
bool8 S9xInitSound (int quality, bool8 stereo, int buffer_size);
void S9xAPUSetEndOfSample (int channel);
void S9xAPUSetEndX (int channel);

void FixEnvelope(int channel, uint8 gain, uint8 adsr1, uint8 adsr2);
void StartSample(int channel);

extern void (*S9xApuOpcodes[256])();

#define APU_VOL_LEFT		0x00
#define APU_VOL_RIGHT		0x01
#define APU_P_LOW		0x02
#define APU_P_HIGH		0x03
#define APU_SRCN		0x04
#define APU_ADSR1		0x05
#define APU_ADSR2		0x06
#define APU_GAIN		0x07
#define APU_ENVX		0x08
#define APU_OUTX		0x09

#define APU_MVOL_LEFT		0x0c
#define APU_MVOL_RIGHT		0x1c
#define APU_EVOL_LEFT		0x2c
#define APU_EVOL_RIGHT		0x3c
#define APU_KON			0x4c
#define APU_KOFF		0x5c
#define APU_FLG			0x6c
#define APU_ENDX		0x7c

#define APU_EFB			0x0d
#define APU_PMON		0x2d
#define APU_NON			0x3d
#define APU_EON			0x4d
#define APU_DIR			0x5d
#define APU_ESA			0x6d
#define APU_EDL			0x7d

#define APU_C0			0x0f
#define APU_C1			0x1f
#define APU_C2			0x2f
#define APU_C3			0x3f
#define APU_C4			0x4f
#define APU_C5			0x5f
#define APU_C6			0x6f
#define APU_C7			0x7f

#define APU_SOFT_RESET		0x80
#define APU_MUTE		0x40
#define APU_ECHO_DISABLED	0x20

#define FREQUENCY_MASK		0x3fff

#endif /*_APU_H_*/
