#ifndef __SPC700_H__
#define __SPC700_H__

typedef          char   int8;
typedef unsigned char  uint8;
typedef          short  int16;
typedef unsigned short uint16;
typedef          long   int32;
typedef unsigned long  uint32;
typedef unsigned char  bool8;

/* PSR̃tO` */
#define Carry		  1
#define Zero		  2
#define Interrupt	  4
#define HalfCarry	  8
#define BreakFlag	 16
#define DirectPageFlag	 32
#define Overflow	 64
#define Negative	128

/* PSR̃tO */
#define APUClearCarry()		(IAPU._Carry = 0)
#define APUSetCarry()		(IAPU._Carry = 1)
#define APUSetInterrupt()	(APURegisters.P |= Interrupt)
#define APUClearInterrupt()	(APURegisters.P &= ~Interrupt)
#define APUSetHalfCarry()	(APURegisters.P |= HalfCarry)
#define APUClearHalfCarry()	(APURegisters.P &= ~HalfCarry)
#define APUSetBreak()		(APURegisters.P |= BreakFlag)
#define APUClearBreak()		(APURegisters.P &= ~BreakFlag)
#define APUSetDirectPage()	(APURegisters.P |= DirectPageFlag)
#define APUClearDirectPage()	(APURegisters.P &= ~DirectPageFlag)
#define APUSetOverflow()	(IAPU._Overflow = 1)
#define APUClearOverflow()	(IAPU._Overflow = 0)

/* PSR̃tO */
#define APUCheckZero()		(IAPU._Zero == 0)
#define APUCheckCarry()		(IAPU._Carry)
#define APUCheckInterrupt()	(APURegisters.P & Interrupt)
#define APUCheckHalfCarry()	(APURegisters.P & HalfCarry)
#define APUCheckBreak()		(APURegisters.P & BreakFlag)
#define APUCheckDirectPage()	(APURegisters.P & DirectPageFlag)
#define APUCheckOverflow()	(IAPU._Overflow)
#define APUCheckNegative()	(IAPU._Zero & 0x80)

/* PSR̃tO/(ėp) */
#define APUClearFlags(f)	(APURegisters.P &= ~(f))
#define APUSetFlags(f)		(APURegisters.P |=  (f))
#define APUCheckFlag(f)		(APURegisters.P &   (f))

/* APŨWX^\
 * PSRPCɂĂAPURegistersϐ𒼐ڎĝł͂ȂA
 * ₷WJꂽSIAPU\(IAPUϐ)g悤łB
 */
typedef union _YAndA {
	struct { uint8 A, Y; } B;
	uint16 W;
} YAndA;
typedef struct _SAPURegisters {
	uint8 P;	/* P:PSR */
	YAndA YA;	/* {A:Acc,Y:Index}or{W:Generic?} */
	uint8 X;	/* X:Index */
	uint8 S;	/* S:Stack */
	uint16 PC;	/* PC */
} SAPURegisters;
extern SAPURegisters APURegisters;

/* 1ߎs */
#define APU_EXECUTE1()	(*S9xApuOpcodes[*IAPU.PC])();

#endif /*__SPC700_H__*/
